'use strict';

Object.defineProperty(exports, "__esModule", {
   value: true
});

var _result2 = require('lodash/result');

var _result3 = _interopRequireDefault(_result2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _Validation = require('../Utils/Validation');

var _Tools = require('../Utils/Tools');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ValidationWrapper = function (_Component) {
   _inherits(ValidationWrapper, _Component);

   function ValidationWrapper() {
      var _ref;

      var _temp, _this, _ret;

      _classCallCheck(this, ValidationWrapper);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
         args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ValidationWrapper.__proto__ || Object.getPrototypeOf(ValidationWrapper)).call.apply(_ref, [this].concat(args))), _this), _this.getDefaultState = function () {
         return {
            value: null,
            error: null,
            valid: true
         };
      }, _this.getValue = function () {
         var _this$props = _this.props,
             state = _this$props.state,
             id = _this$props.id;

         if (id) return (0, _result3.default)(state, id, _this.getDefaultState());
         return _extends({}, _this.getDefaultState(), state || {});
      }, _this.buildField = function (value) {
         var _this$props2 = _this.props,
             validation = _this$props2.validation,
             validators = _this$props2.validators,
             postValidation = _this$props2.postValidation;


         var fieldData = _this.getValue();

         return _extends({}, fieldData, {
            validators: validators,
            validation: validation,
            postValidation: postValidation,
            value: value === undefined ? fieldData.value : value,
            __flum: true
         });
      }, _this.onChange = function (value) {
         var _this$props3 = _this.props,
             onChange = _this$props3.onChange,
             state = _this$props3.state,
             id = _this$props3.id;

         var field = _this.buildField(value);

         onChange((0, _Tools.buildState)(state, (0, _Validation.validateField)(field), id));
      }, _temp), _possibleConstructorReturn(_this, _ret);
   }

   _createClass(ValidationWrapper, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
         this.onChange();
      }
   }, {
      key: 'render',
      value: function render() {
         var children = this.props.children;

         var state = this.getValue();

         return children ? children({
            value: state.value,
            error: state.error,
            valid: state.valid,
            onChange: this.onChange
         }) : null;
      }
   }]);

   return ValidationWrapper;
}(_react.Component);

ValidationWrapper.propTypes = {
   children: _react.PropTypes.func,

   state: _react.PropTypes.object,
   id: _react.PropTypes.string,

   onChange: _react.PropTypes.func,

   validation: _react.PropTypes.string,
   postValidation: _react.PropTypes.string,

   validators: _react.PropTypes.object
};
exports.default = ValidationWrapper;